package org.university.core;

import java.util.ArrayList;

public abstract class Employee extends Person {
    protected ArrayList<Statement> bankStatements;
    protected String position;
    protected double basicIncome;
    protected double requiredIncome;
    protected double balance;

    public Employee(String firstName, String lastName, String id, int joiningYear, Department department, String position
            , double basicIncome, int currentYear) {
        super(firstName, lastName, id, joiningYear, department, currentYear);
        this.position = position;
        this.bankStatements = new ArrayList<>();
        this.basicIncome = basicIncome;
        this.balance = 0;
    }

    public void addBankStatements(Statement s) {
        this.bankStatements.add(s);
    }

    public ArrayList<Statement> getBankStatements() {
        return bankStatements;
    }

    public String getPosition() {
        return position;
    }

    public void setBasicIncome(double basicIncome) {
        this.basicIncome = basicIncome;
    }

    public double getBasicIncome() {
        return basicIncome;
    }

    public abstract Boolean isPromotable();
}
