package org.university.core;

import java.util.ArrayList;

public class GradStudent extends Student implements AccountInterface{
    private ArrayList<Publication> publications;
    private Professor advisor;
    private double balance;
    private double requiredIncome;
    private double basicIncome;

    public GradStudent(String firstName, String lastName, String id, int joiningYear, Department department, ArrayList<Course> courses,  Professor advisor) {
        super(firstName, lastName, id, joiningYear, department, courses);
        this.publications = new ArrayList<Publication>();
        this.advisor = advisor;
        this.balance = 0;
    }

    public ArrayList<Publication> getPublications() {
        return publications;
    }

    public void addPublication(Publication publication)
    {
        this.publications.add(publication);
    }

    public void setRequiredIncome(double requiredIncome) {
        this.requiredIncome = requiredIncome;
    }

    public void setBasicIncome(double basicIncome) {
        this.basicIncome = basicIncome;
    }

    @Override
    public double checkout()
    {
        this.balance += requiredIncome;
        return requiredIncome;
    }
    @Override
    public double getBalance() {
        return balance;
    }

    @Override
    public double calCurrentIncome()
    {
        this.balance += basicIncome + publications.size() * 1000;
        return basicIncome + publications.size() * 1000;
    }

    @Override
    public Person getSender()
    {
        return this;
    }

}
